
--------------------------Globals----------------------------------------------

ddExport = {
	["Export"] = {
		["History"] = {},
	},
	["Name"] = "ddExport",
}

local dd = DataDaedra
local ddX = ddExport

-------------------------------------------------------------------------------


--------------------------Main Export/Import Functions-------------------------

function dd.ExPortal()
	local Sigil = dd.Sigilstone.History
	local ExPortal = ddX.Export.History
	
	if not ExPortal then
		ExPortal = {}
	elseif not Sigil then
		dd.DataHarvest()
		return
	end

	for timestamp, record in pairs(Sigil) do
		if not ExPortal[timestamp] then
			table.insert(ExPortal, timestamp, record)
						
		elseif ExPortal[timestamp] then
			if dd.IsUnique(record, ExPortal[timestamp]) then
				for index = (timestamp - 1), (timestamp - 5), 1 do
					if not ExPortal[index] then
						table.insert(ExPortal, index, record)
					end
				end
			end
		end	
	end
	
	dd.Revisionist(ExPortal)
	dd.CloneHound(ExPortal)
end

function dd.ImPortal()
	local ImPortal = ddX.Export.History
	local Sigil = dd.Sigilstone.History
	
	if not ImPortal then 
		return
	elseif not Sigil then
		Sigil = {}
	end
	
	for timestamp, record in pairs(ImPortal) do
		if not Sigil[timestamp] then
			table.insert(Sigil, timestamp, record)
						
		elseif Sigil[timestamp] then
			if dd.IsUnique(record, Sigil[timestamp]) then
				for index = (timestamp - 1), (timestamp - 5), 1 do
					if not Sigil[index] then
						table.insert(Sigil, index, record)
					end
				end																
			end
		end	
	end
	
	dd.Revisionist(Sigil)
	dd.CloneHound(Sigil)
end

function dd.SealPortal()
	local ExPortal = ddX.Export.History
	
	if not ExPortal then 
		return
	end
	
	ExPortal = {}
end

-------------------------------------------------------------------------------


--------------------------Addon Extension Loader-------------------------------

function ddX.LiminalGate(eventCode, addOnName)
	if addOnName ~= ddX.Name then 
		return
	else
		dd.ddExport = true
	end
	
	ddX.Export = ZO_SavedVars:NewAccountWide("Export", 2, nil, ddX.Export, "Global")
	
	SLASH_COMMANDS["/ddexport"] 	= dd.ExPortal
	SLASH_COMMANDS["/ddimport"] 	= dd.ImPortal
	SLASH_COMMANDS["/ddclrexport"] 	= dd.SealPortal
	SLASH_COMMANDS["/ddtranslate"] 	= ddX.TranslateSigil
end

EVENT_MANAGER:RegisterForEvent(ddX.Name, EVENT_ADD_ON_LOADED, ddX.LiminalGate)

-------------------------------------------------------------------------------
